/* (C) Copyright International Business Machines Corporation 23 January  */
/* 1990.  All Rights Reserved.  */
/*   */
/* See the file USERAGREEMENT distributed with this software for full  */
/* terms and conditions of use.  */
/* File: Makefile */
/* Author: David F. Bacon */
/* SCCS Info: @(#)Makefile	1.14 2/7/92 */

/* Makefile for those parts of the Hermes typechecker that are common to both */
/* the bootstrapped and the production versions. */

/* sources */
MAINSRC	=	findtype.p finddef.p componentsoverlap.p infer.p assign.p

INFERSRC=	sameas.p casetypeof.p matchinginportof.p \
		messagetypeof.p elementtypeof.p
 
ASSIGNSRC=	predefinedprogram.p predefineddefinitionsmodule.p \
		predefineddefinitionsmodules.p predefinedboolean.p \
		predefinedtypeofvalue.p predefinedtypestateofvalue.p \
		predefinedinteger.p predefinedtypename.p \
		predefinedattribute_name.p

SRC	=	$(MAINSRC) $(INFERSRC) $(ASSIGNSRC)

/* objects */
MAINOBJ	=	findtype.po finddef.po componentsoverlap.po infer.po assign.po
MAINOBJZ =	findtype.po.Z finddef.po.Z componentsoverlap.po.Z \
		infer.po.Z assign.po.Z

INFEROBJ=	sameas.po casetypeof.po matchinginportof.po \
		messagetypeof.po elementtypeof.po
INFEROBJZ=	sameas.po.Z casetypeof.po.Z matchinginportof.po.Z \
		messagetypeof.po.Z elementtypeof.po.Z

ASSIGNOBJ=	predefinedprogram.po predefineddefinitionsmodule.po \
		predefineddefinitionsmodules.po predefinedboolean.po \
		predefinedtypeofvalue.po predefinedtypestateofvalue.po \
		predefinedinteger.po predefinedtypename.po \
		predefinedattribute_name.po
ASSIGNOBJZ=	predefinedprogram.po.Z predefineddefinitionsmodule.po.Z \
		predefineddefinitionsmodules.po.Z predefinedboolean.po.Z \
		predefinedtypeofvalue.po.Z predefinedtypestateofvalue.po.Z \
		predefinedinteger.po.Z predefinedtypename.po.Z \
		predefinedattribute_name.po.Z

PROCOBJS =	$(MAINOBJ) $(INFEROBJ) $(ASSIGNOBJ)
PROCOBJSZ =	$(MAINOBJZ) $(INFEROBJZ) $(ASSIGNOBJZ)


#include "includefile"

TCDEFDIR =	$(HROOT)/type/defs
DEFPATH	=	$(TCDEFDIR):$(DEFDIR)

/* targets */

all: 	compileprocs

/* installation */

/* dependencies due to static linking */
infer.po:	$(INFEROBJ)
assign.po:	$(ASSIGNOBJ)
